#!/usr/bin/env python3

# Copyright 2014 Brett Slatkin, Pearson Education Inc.
#
# Udostępniono na licencji Apache w wersji 2.0 ("Licencja").
# Tego pliku można używać jedynie zgodnie z warunkami Licencji.
# Treść Licencji znajdziesz na stronie:
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# O ile obowiązujące prawo nie stanowi inaczej lub czegoś innego nie
# uzgodniono w formie pisemnej, oprogramowanie objęte Licencją jest
# dostarczane w stanie, w jakim jest (wersja "AS IS"), BEZ JAKIEJKOLWIEK
# GWARANCJI, ani wyrażonej otwarcie, ani domyślnej. Dokładne zasady
# i warunki Licencji znajdziesz w jej treści.

# Przygotowania mające na celu odtworzenie środowiska użytego w książce.
import logging
from pprint import pprint
from sys import stdout as STDOUT


# Przykład 1.
for i in range(3):
    print('Pętla %d' % i)
else:
    print('Blok else!')


# Przykład 2.
for i in range(3):
    print('Pętla %d' % i)
    if i == 1:
        break
else:
    print('Blok else!')


# Przykład 3.
for x in []:
    print('Nigdy nie będzie wykonane')
else:
    print('Blok else pętli for!')


# Przykład 4.
while False:
    print('Nigdy nie będzie wykonane')
else:
    print('Blok else pętli while!')


# Przykład 5.
a = 4
b = 9

for i in range(2, min(a, b) + 1):
    print('Sprawdzanie', i)
    if a % i == 0 and b % i == 0:
        print('To nie jest liczba pierwsza')
        break
else:
    print('Liczba pierwsza')


# Przykład 6.
def coprime(a, b):
    for i in range(2, min(a, b) + 1):
        if a % i == 0 and b % i == 0:
            return False
    return True
print(coprime(4, 9))
print(coprime(3, 6))


# Przykład 7.
def coprime2(a, b):
    is_coprime = True
    for i in range(2, min(a, b) + 1):
        if a % i == 0 and b % i == 0:
            is_coprime = False
            break
    return is_coprime
print(coprime2(4, 9))
print(coprime2(3, 6))
